明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 4857|回复: 5

关于偏移GetOffset的使用方法,点哪边则偏移哪边(偏移方向)!

  [复制链接]
发表于 2014-6-1 15:33:26 | 显示全部楼层 |阅读模式
using System;

using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Geometry;

[assembly: CommandClass(typeof(qian2014531.qian2014531a))]
namespace qian2014531
{
    class qian2014531a
    {
        [CommandMethod("sf")]
        public void qianpp()
        {

            Document doc = Application.DocumentManager.MdiActiveDocument;
            Database db = doc.Database;
            Editor ed = doc.Editor;
            PromptEntityResult ent = ed.GetEntity("选择实体");
            Entity entity = null;
            using (Transaction transaction = db.TransactionManager.StartTransaction())
            {
                entity = (Entity)transaction.GetObject(ent.ObjectId, OpenMode.ForRead, true);
                transaction.Commit();
            }

            // 拾取点,指定偏移的方向“点 ”
            PromptPointResult pPtRes;
            PromptPointOptions pPtOpts = new PromptPointOptions("");
            pPtOpts.Message = "\nEnter the start point of the line: ";
            pPtRes = doc.Editor.GetPoint(pPtOpts);
            Point3d DirectOffsetPt = pPtRes.Value;

            double offsetDist = 10;
            Curve mycurve = entity as Curve;
            Point3d offPtNew = new Point3d(DirectOffsetPt.X, DirectOffsetPt.Y, 0);
         //这里开始判断偏移的方向
            Point3d pt1 = mycurve.GetClosestPointTo(offPtNew, false);
            pt1 = new Point3d(pt1.X, pt1.Y, 0);
            Vector3d vec1 = offPtNew - pt1;
            Vector3d vec2 = mycurve.GetFirstDerivative(pt1);
            Vector3d vec3 = vec1.CrossProduct(vec2);
            if (vec3.Z < 0)
            {
                offsetDist = -offsetDist;
            }

            if (mycurve.GetType() == typeof(Line))
            {
                offsetDist = -offsetDist;
            }
         //结束,这里开始判断偏移的方向



            using (Transaction acTrans = db.TransactionManager.StartTransaction())  
   {
           // 以读模式打开Block 表
           BlockTable acBlkTbl;
           acBlkTbl = acTrans.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;

           // 以写模式打开块表记录模型空间
           BlockTableRecord acBlkTblRec;
           acBlkTblRec =acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],OpenMode.ForWrite) as BlockTableRecord;

           DBObjectCollection objCol = new DBObjectCollection();
           objCol = mycurve.GetOffsetCurves(offsetDist);

           // 遍历得到的新对象
           foreach (Curve acEnt in objCol)
           {
               // 添加每个对象
               acBlkTblRec.AppendEntity(acEnt);
               acTrans.AddNewlyCreatedDBObject(acEnt, true);
           }

           acTrans.Commit();
   }

        }
    }
}

发表于 2014-6-3 09:54:38 | 显示全部楼层
试了一下,挺好
发表于 2014-6-4 15:16:18 | 显示全部楼层
VBA  ActiveX API  COM 下如何完成呢?
 楼主| 发表于 2014-6-5 15:09:24 | 显示全部楼层
Student 发表于 2014-6-3 09:54
试了一下,挺好

抛砖引玉,大家可以都来讨论
 楼主| 发表于 2014-6-5 20:13:20 | 显示全部楼层
Student 发表于 2014-6-3 09:54
试了一下,挺好

同理用叉积方法,即可,
发表于 2014-6-6 09:48:00 | 显示全部楼层
感谢 jiikoo 的提示-----“同理用叉积方法,即可”!!
能否给出VBA  ActiveX API  COM 下的 多段线“点哪边则偏移哪边(偏移方向)” 代码呢!? 谢谢!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 12:39 , Processed in 0.177917 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表